<?php

/**
 * horas_extras actions.
 *
 * @package    nomina
 * @subpackage horas_extras
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class horas_extrasActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_HR_EXTRA',
        'NO_DATOS_FUNCIONARIO_V',
        'NO_LOTE_HR_EXTRA',
        'NO_TIPO_HR_EXTRA',
        'NO_PERIODO',
        'NO_TIPO_PERIODO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_LOTE_HR_EXTRA' =>
        array(
            'id_lote_hr_extra' => 'NO_HR_EXTRA'
        ),
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'id_tipo_doc' => 'NO_HR_EXTRA',
            'num_doc' => 'NO_HR_EXTRA'
        ),
        'NO_TIPO_HR_EXTRA' =>
        array(
            'id_tipo_hr_extra' => 'NO_HR_EXTRA'
        ),
        'NO_PERIODO' =>
        array(
            'id_periodo' => 'NO_LOTE_HR_EXTRA'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'id_tipo_periodo' => 'NO_PERIODO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_HR_EXTRA' =>
        array(
            'id_hr_extra' => 'id_hr_extra',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'id_lote_hr_extra' => 'id_lote_hr_extra',
            'id_tipo_hr_extra' => 'id_tipo_hr_extra',
            'fecha' => 'fecha',
            'cantidad' => 'cantidad',
            'valor_liquidado' => 'valor_liquidado'
        ),
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'nombre_completo' => 'nombre_completo'
        ),
        'NO_TIPO_HR_EXTRA' =>
        array(
            'codigo' => 'codigo_tipo',
            'descripcion' => 'descripcion_tipo',
            'codigo,||, - ,||,descripcion' => 'completo_tipo'
        ),
        'NO_LOTE_HR_EXTRA' =>
        array(
            'total_horas' => 'total_horas',
            'estado' => 'estado'
        ),
        'NO_PERIODO' =>
        array(
            'id_meses' => 'id_meses',
            'id_anhos' => 'id_anhos'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'descripcion' => 'descripcion_periodo'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_HR_EXTRA' => array(
            'id_hr_extra,a' => array('!=' => array(-1)),
            'id_hr_extra,b' => array('=' => array('id_hr_extra')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'num_doc' => array('=' => array('num_doc')),
            'id_tipo_hr_extra' => array('=' => array('id_tipo_hr_extra')),
            'id_lote_hr_extra' => array('=' => array('id_lote_hr_extra')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'num_doc'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_hr_extra'; //identificador de la tabla
    protected $id_names = array('id_hr_extra'); //llave primaria
    protected $field_names = array('id_tipo_doc', 'num_doc', 'id_lote_hr_extra', 'fecha', 'cantidad', 'valor_liquidado', 'id_tipo_hr_extra'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_HR_EXTRA'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_hr_extra'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        $id_tipo_doc = $request['id_tipo_doc'];
        $num_doc = $request['num_doc'];
        $id_periodo = $request['id_periodo'];
        $id_tipo_hr_extra = $request['id_tipo_hr_extra'];
        $fecha = $request['fecha'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        $sql = <<<EOD
select * 
from no_param_gen
where
id_param_gen = 1
EOD;
        $records = CN_TABLE::executeSQL($sql);

        $maximo_hr_extra = $records[0]['maximo_hr_extra'];


        $sql = <<<EOD
select * 
from no_nombramiento
where
id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc'
EOD;
        $records = CN_TABLE::executeSQL($sql);
        /*
         *  Generar errores en $errors
         */
        if (count($records) == 0) {
            $errors['mensaje'] = "Este Funcionario no se encuentra nombrado, favor verificar";
            $errors['servicio'] = "horas_extras";
        }

        $sql = <<<EOD
select nvl(sum(nvl(tab0.cantidad,0)),0) AS CANTIDAD 
from no_lote_hr_extra tab1
left join no_hr_extra tab0 ON tab1.id_lote_hr_extra = tab0.id_lote_hr_extra
where
tab0.id_tipo_doc = $id_tipo_doc 
and tab0.num_doc = '$num_doc'
and tab1.id_periodo = $id_periodo   
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $num_horas = $records[0]['cantidad'] + $request['cantidad'];

        //limite de horas por Funcionario
        if ($num_horas > $maximo_hr_extra) {

            $errors['mensaje'] = "Ha superado el limite de horas por Funcionario. No se guardara este registro";
            $errors['servicio'] = "horas_extras";
        }

        //limite de horas por lote 
        //solo uno activo en el mes por registros - 20130816
        $sql = <<<EOD
select 
tab1.total_horas as total,sum(nvl(tab0.cantidad,0)) as cantidad 
from no_lote_hr_extra tab1
left join no_hr_extra tab0 on tab1.id_lote_hr_extra = tab0.id_lote_hr_extra
where tab1.id_periodo = $id_periodo
and tab1.estado = 1
group by tab1.total_horas
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $num_horas = $records[0]['cantidad'] + $request['cantidad'];
        $total_horas = $records[0]['total'];

        if ($num_horas > $total_horas) {

            $errors['mensaje'] = "Ha superado el limite de horas del Lote. No se guardara este registro";
            $errors['servicio'] = "horas_extras";
        }

        //Validar que por fecha no deje mas de un registro por tipo - 20211020
        $sql = <<<EOD
select 
tab0.*
from no_lote_hr_extra tab1
left join no_hr_extra tab0 on tab1.id_lote_hr_extra = tab0.id_lote_hr_extra
where 
tab0.id_tipo_doc = $id_tipo_doc 
and tab0.num_doc = '$num_doc'
and tab0.id_tipo_hr_extra = $id_tipo_hr_extra
and tab0.fecha = to_date('$fecha','yyyy-mm-dd')
--and tab1.estado = 0 
EOD;

        $records = CN_TABLE::executeSQL($sql);

        if (count($records) > 0) {

            $errors['mensaje'] = "</br>No se puede registrar para el mismo tipo de hora en la misma fecha. No se guardara este registro.";
            $errors['servicio'] = "horas_extras";
        }


        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $id_tipo_hr_extra = $request['id_tipo_hr_extra'];
            $id_tipo_doc = $request['id_tipo_doc'];
            $num_doc = $request['num_doc'];
            $num_horas = $request['cantidad'];

            $sql = <<<EOD
            select * 
            from no_tipo_hr_extra
            where id_tipo_hr_extra = $id_tipo_hr_extra
EOD;

            $results = CN_TABLE::executeSQL($sql);


            $factor = $results[0]['factor'];

            $logger->info("Factor:: " . $factor);

            /**
             * Incidente #39965, se verifica que tome el ultimo registro y no otros posibles nombramientos. - 20250519::LAVILA
             */
            $sql = <<<EOD
select * 
from no_nombramiento_v
where
id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc'
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $horas_mes = $records[0]['horas_mes'];

            $logger->info("Horas Mes:: " . $horas_mes);

            $sql = "select estado.*
        from no_concepto_func estado
        join no_param_concep parametros ON parametros.id_concep_basica = estado.id_concep_nomina
        where estado.estado=1 and estado.actual=1 and estado.id_tipo_doc = $id_tipo_doc and estado.num_doc='$num_doc'";

            $results = CN_TABLE::executeSQL($sql);

            $asignacion_basica = $results[0]['valor'];
            $logger->info("Asignacion Basica:: " . $asignacion_basica);


            $valor_liquidado = 0;

            $valor_liquidado = ($asignacion_basica / $horas_mes) * $factor * $num_horas;

            //SGC: horas extra sin decimales - 20140319
            $request['valor_liquidado'] = round($valor_liquidado);
        }

        //accion update
        if ($Action == "UPDATE") {

            $id_tipo_hr_extra = $request['id_tipo_hr_extra'];
            $id_tipo_doc = $request['id_tipo_doc'];
            $num_doc = $request['num_doc'];
            $num_horas = $request['cantidad'];

            $sql = <<<EOD
            select * 
            from no_tipo_hr_extra
            where id_tipo_hr_extra = $id_tipo_hr_extra
EOD;

            $results = CN_TABLE::executeSQL($sql);


            $factor = $results[0]['factor'];

            $logger->info("Factor " . $factor);

            /**
             * Incidente #39965, se verifica que tome el ultimo registro y no otros posibles nombramientos. - 20250519::LAVILA
             */
            $sql = <<<EOD
select * 
from no_nombramiento_v
where
id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc'
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $horas_mes = $records[0]['horas_mes'];

            $logger->info("Horas Mes " . $horas_mes);

            $sql = "select estado.*
        from no_concepto_func estado
        join no_param_concep parametros ON parametros.id_concep_basica = estado.id_concep_nomina
        where estado.estado=1 and estado.actual=1 and estado.id_tipo_doc = $id_tipo_doc and estado.num_doc='$num_doc'";

            $results = CN_TABLE::executeSQL($sql);

            $asignacion_basica = $results[0]['valor'];
            $logger->info("Asignacion Basica " . $asignacion_basica);


            $valor_liquidado = 0;

            $valor_liquidado = ($asignacion_basica / $horas_mes) * $factor * $num_horas;

            //SGC: horas extra sin decimales - 20140319
            $request['valor_liquidado'] = round($valor_liquidado);
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
